'use strict';

var BoletimMedicaoFornecedorAllController = angular.module('BoletimMedicaoFornecedorAllController', []);

BoletimMedicaoFornecedorAllController.controller('BoletimMedicaoFornecedorAllCtrl', ['$scope', '$filter', 'Relatorio', 'Compra', 'CacheApp',
  ($scope, $filter, Relatorio, Compra, CacheApp) => {
    $scope.construcao = CacheApp.getConstrucao();

    $scope.Opcoes = [
        {Id: 0, Descricao: 'Sem BDI e encargos'},
        {Id: 1, Descricao: 'Com BDI e sem encargos'},
        {Id: 2, Descricao: 'Sem BDI e com encargos'},
        {Id: 3, Descricao: 'Com BDI e Encargos'}
    ];

    $scope.relatorio = {};
    $scope.relatorio.DataInicio = CacheApp.getData($scope.construcao.DataInicio ? $filter("date")($scope.construcao.DataInicio, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
    $scope.relatorio.DataFim = CacheApp.getData($scope.construcao.DataFim ? $filter("date")($scope.construcao.DataFim, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
    $scope.relatorio.OpcaoSelecionada = {Id: 0, Descricao: 'Sem BDI e Encargos'};
    $scope.relatorio.IdCount = 1;
    $scope.relatorio.TipoVinculo = 1;

    $scope.assinatura = true;
    $scope.descricaoObra = true;


    $scope.getBoletimMedicao = () => {
        function loadBM(ids) {
            var params = { 
                Opcao: $scope.relatorio.OpcaoSelecionada.Id,
                IdConstrucao: $scope.construcao.Id, 
                DataInicio: $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'),
                DataFim: $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'),
                Fornecedor: $scope.relatorio.TipoVinculo == 1,
                Ids: ids
                // IdFuncionario: $scope.relatorio.TipoVinculo == 2 ? $scope.relatorio.FuncionarioSelecionado.Id : undefined,
                // IdFornecedorCliente: $scope.relatorio.TipoVinculo == 1 ? $scope.relatorio.FornecedorSelecionado.Id : undefined
            }
    
            Relatorio.getBoletimMedicaoFornecedorAll(params,
                (data) => {
                    $scope.boletimMedicao = data.Instance
                    // for (var i in $scope.boletimMedicao.Etapas) {
                    //     $scope.boletimMedicao.Etapas[i].ValorTotal = 0
                    //     $scope.boletimMedicao.Etapas[i].AvancoTotal = 0
                    //     for (var j in $scope.boletimMedicao.Etapas[i].Itens) {
                    //         $scope.boletimMedicao.Etapas[i].ValorTotal += $scope.boletimMedicao.Etapas[i].Itens[j].ValorAvanco
                    //         $scope.boletimMedicao.Etapas[i].AvancoTotal += $scope.boletimMedicao.Etapas[i].Itens[j].IncidenciaAvanco
                    //     }
                    //     $scope.relatorio.ValorTotal += $scope.boletimMedicao.Etapas[i].ValorTotal
                    //     $scope.relatorio.AvancoTotal += $scope.boletimMedicao.Etapas[i].AvancoTotal
                    // }
                }
            )
        }

        $scope.boletimMedicao = {}
        $scope.relatorio.ValorTotal = 0
        $scope.relatorio.AvancoTotal = 0

        if ($scope.relatorio.TipoVinculo == 1)
            $scope.getFornecedorMedicao((lista) => {
                var ids = []
                lista.forEach(l => {
                    ids.push(l.Id)
                })
                loadBM(ids)
            })
        else
            $scope.getFuncionarioMedicao((lista) => {
                var ids = []
                lista.forEach(l => {
                    ids.push(l.Id)
                })
                loadBM(ids)
            })
    }
    // $scope.getBoletimMedicao();

    $scope.pdfBoletimMedicao = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.relatorio.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.relatorio.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda,
            DescricaoObra: $scope.relatorio.TipoVinculo == 1 ? 
                `Fornecedor: ${$scope.relatorio.FornecedorSelecionado.Cnpj} | ${$scope.relatorio.FornecedorSelecionado.RazaoSocial}` : 
                `Colaborador: ${$scope.relatorio.FuncionarioSelecionado.Nome}`
        };

        if ($scope.assinatura == true) {
            cabecalho.Responsavel = $scope.construcao.Contato
        };
        if ($scope.descricaoObra == true) {
            cabecalho.DescricaoObra += '\n' + $scope.construcao.Descricao
        };

        var params = { 
            Opcao: $scope.relatorio.OpcaoSelecionada.Id,
            IdConstrucao: $scope.construcao.Id, 
            DataInicio: $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'),
            DataFim: $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'),
            IdFuncionario: $scope.relatorio.TipoVinculo == 2 ? $scope.relatorio.FuncionarioSelecionado.Id : undefined,
            IdFornecedorCliente: $scope.relatorio.TipoVinculo == 1 ? $scope.relatorio.FornecedorSelecionado.Id : undefined,
            Cabecalho: cabecalho
        }

        Relatorio.pdfBoletimMedicaoFornecedor(params,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    // $scope.xlsBoletimMedicao = () => {
    //     var cabecalho = {
    //         Avatar: $scope.construcao.ContaAvatar,
    //         Obra: $scope.construcao.Titulo,
    //         Conta: $scope.construcao.Conta,
    //         DataInicio: $filter("date")($scope.relatorio.DataInicio, 'dd/MM/yyyy'),
    //         DataFim: $filter("date")($scope.relatorio.DataFim, 'dd/MM/yyyy'),
    //         Moeda: $scope.construcao.Moeda,
    //         DescricaoObra: $scope.relatorio.TipoVinculo == 1 ? 
    //             `Fornecedor: ${$scope.relatorio.FornecedorSelecionado.Cnpj} | ${$scope.relatorio.FornecedorSelecionado.RazaoSocial}` : 
    //             `Colaborador: ${$scope.relatorio.FuncionarioSelecionado.Nome}`
    //     };

    //     var params = { 
    //         Opcao: $scope.relatorio.OpcaoSelecionada.Id,
    //         IdConstrucao: $scope.construcao.Id, 
    //         DataInicio: $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'),
    //         DataFim: $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'),
    //         IdFuncionario: $scope.relatorio.TipoVinculo == 2 ? $scope.relatorio.FuncionarioSelecionado.Id : undefined,
    //         IdFornecedorCliente: $scope.relatorio.TipoVinculo == 1 ? $scope.relatorio.FornecedorSelecionado.Id : undefined,
    //         Cabecalho: cabecalho
    //     }

    //     Relatorio.xlsBoletimMedicaoFornecedor(params,
    //         (data) => {
    //             window.location.assign(data.Instance);
    //         });
    // }

    $scope.xlsBoletimMedicao = () => {
        function loadBM(ids) {
            var cabecalho = {
                Avatar: $scope.construcao.ContaAvatar,
                Obra: $scope.construcao.Titulo,
                Conta: $scope.construcao.Conta,
                DataInicio: $filter("date")($scope.relatorio.DataInicio, 'dd/MM/yyyy'),
                DataFim: $filter("date")($scope.relatorio.DataFim, 'dd/MM/yyyy'),
                Moeda: $scope.construcao.Moeda,
                // DescricaoObra: $scope.relatorio.TipoVinculo == 1 ? 
                //     `Fornecedor: ${$scope.relatorio.FornecedorSelecionado.Cnpj} | ${$scope.relatorio.FornecedorSelecionado.RazaoSocial}` : 
                //     `Colaborador: ${$scope.relatorio.FuncionarioSelecionado.Nome}`
            }

            var params = { 
                Cabecalho: cabecalho,
                Opcao: $scope.relatorio.OpcaoSelecionada.Id,
                IdConstrucao: $scope.construcao.Id, 
                DataInicio: $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'),
                DataFim: $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'),
                Fornecedor: $scope.relatorio.TipoVinculo == 1,
                Ids: ids
            }
    
            Relatorio.xlsBoletimMedicaoFornecedorAll(params,
                (data) => {
                    window.location.assign(data.Instance)
                }
            )
        }

        // $scope.boletimMedicao = {}
        // $scope.relatorio.ValorTotal = 0
        // $scope.relatorio.AvancoTotal = 0

        if ($scope.relatorio.TipoVinculo == 1)
            $scope.getFornecedorMedicao((lista) => {
                var ids = []
                lista.forEach(l => {
                    ids.push(l.Id)
                })
                loadBM(ids)
            })
        else
            $scope.getFuncionarioMedicao((lista) => {
                var ids = []
                lista.forEach(l => {
                    ids.push(l.Id)
                })
                loadBM(ids)
            })
    }


    $scope.getFuncionarioMedicao = (callBack) => {
        Compra.getFuncionarioMedicao({IdConstrucao: $scope.construcao.Id},
            (data) => {
                // $scope.funcionarios = data.Instance;
                callBack(data.Instance)
            });
    }
    // $scope.getListaFuncionario();

    $scope.getFornecedorMedicao = (callBack) => {
        Compra.getFornecedorMedicao({IdConstrucao: $scope.construcao.Id},
            (data) => {
                // $scope.fornecedores = data.Instance;
                callBack(data.Instance)
            });
    }
    // $scope.getListaFornecedor();

}]);
